首页
登录 | 注册

java异常处理中throw和throws的区别?

throw和throws的区别主要有两点!
1、throw 后面跟的是对象,throws后面跟的是异常类
2、throw 定义函数体的内部,throws定义在函数名后。

//抛出异常对象的类型
class Demo {
	public void getValue(int a, int b) throws MyException {
		if (b < 0)
			// 抛出异常对象
			throw new MyException("除数不能为零!");
	}
}

// 自定义异常要继承Exception 类
class MyException extends Exception {
	public MyException(String message){
		super(message)
	}
}

class MainTest {
	public static void main(String[] args) {
		try {
			Demo demo = new Demo();
			demo.getValue(3, -1);
		} catch (MyException e) {
			e.printStackTrace();
		}
	}
}


注意:
1、自定义异常一定要继承Exception类,或者Throwable类,只有继承了Exception、Throwable、error才可以往外抛及使用throws
2、Exception中有一个特殊的子类异常RuntimeException运行时异常,如果在函数内抛出异常,函数上可以不用声明,编译一样通过。如果在 函数上声明了该异常,调用者可以不用不进行处理,编译一样能通过。之所以不用在函数上声明,是因为不需要让调用者处理,当该异常发 生,希望程序停止,因为在运行时出现了无法继续运算的情况,希望停止程序后,对程序进行修正。

//抛出异常对象的类型
class Demo {
	// Runntime类型的异常不需要抛出异常类型
	public void show(String name) {
		if (name.equals("lisi"))
			// 抛出Runntime异常对象
			throw new RunntimeException("出现空指针了!");
	}
}

class MainTest {
	public static void main(String[] args) {
		Demo demo = new Demo();
		// 运行时异常不需要catch
		demo.show(null);
	}
}




2020 jeepxie.net webmaster#jeepxie.net
10 q. 0.008 s.
京ICP备10005923号